<?php

namespace shippypro\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Void ServiceType
 * @subpackage Services
 */
class _Void extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named VoidShipments
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \shippypro\StructType\VoidShipments $parameters
     * @return \shippypro\StructType\VoidShipmentsResponse|bool
     */
    public function VoidShipments(\shippypro\StructType\VoidShipments $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->VoidShipments($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \shippypro\StructType\VoidShipmentsResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
