<?php

namespace shippypro\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BookPickupResponse StructType
 * @subpackage Structs
 */
class BookPickupResponse extends AbstractStructBase
{
    /**
     * The Result
     * @var string
     */
    public $Result;
    /**
     * The Message
     * @var string
     */
    public $Message;
    /**
     * The ConfirmationID
     * @var string
     */
    public $ConfirmationID;
    /**
     * Constructor method for BookPickupResponse
     * @uses BookPickupResponse::setResult()
     * @uses BookPickupResponse::setMessage()
     * @uses BookPickupResponse::setConfirmationID()
     * @param string $result
     * @param string $message
     * @param string $confirmationID
     */
    public function __construct($result = null, $message = null, $confirmationID = null)
    {
        $this
            ->setResult($result)
            ->setMessage($message)
            ->setConfirmationID($confirmationID);
    }
    /**
     * Get Result value
     * @return string|null
     */
    public function getResult()
    {
        return $this->Result;
    }
    /**
     * Set Result value
     * @param string $result
     * @return \shippypro\StructType\BookPickupResponse
     */
    public function setResult($result = null)
    {
        // validation for constraint: string
        if (!is_null($result) && !is_string($result)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($result, true), gettype($result)), __LINE__);
        }
        $this->Result = $result;
        return $this;
    }
    /**
     * Get Message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param string $message
     * @return \shippypro\StructType\BookPickupResponse
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->Message = $message;
        return $this;
    }
    /**
     * Get ConfirmationID value
     * @return string|null
     */
    public function getConfirmationID()
    {
        return $this->ConfirmationID;
    }
    /**
     * Set ConfirmationID value
     * @param string $confirmationID
     * @return \shippypro\StructType\BookPickupResponse
     */
    public function setConfirmationID($confirmationID = null)
    {
        // validation for constraint: string
        if (!is_null($confirmationID) && !is_string($confirmationID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($confirmationID, true), gettype($confirmationID)), __LINE__);
        }
        $this->ConfirmationID = $confirmationID;
        return $this;
    }
}
